<?php

function plugin_init_uptime() {
	global $plugin_hooks;
	$plugin_hooks['config_form']['uptime'] = 'uptime_config_form';
	$plugin_hooks['api_device_save']['uptime'] = 'uptime_api_device_save';
	$plugin_hooks['poller_bottom']['uptime'] = 'uptime_poller_bottom';
	$plugin_hooks['config_arrays']['uptime'] = 'uptime_config_arrays';
	$plugin_hooks['top_header_tabs']['uptime'] = 'uptime_show_tab';	
	$plugin_hooks['top_graph_header_tabs']['uptime'] = 'uptime_show_tab';
	$plugin_hooks['draw_navigation_text']['uptime'] = 'uptime_draw_navigation_text';
	$plugin_hooks['device_action_array']['uptime'] = 'uptime_device_action_array';
	$plugin_hooks['device_action_execute']['uptime'] = 'uptime_device_action_execute';
	$plugin_hooks['device_action_prepare']['uptime'] = 'uptime_device_action_prepare';
}

function uptime_version () {
	return array( 'name' 		=> 'uptime',
			'version' 	=> '0.3',
			'longname'	=> 'Uptime',
			'author'	=> 'Gilles Boulon',
			'homepage'	=> 'http://forums.cacti.net/viewtopic.php?t=13510',
			'email'		=> '',
			'url'		=> ''
			);
}

function uptime_device_action_array($actions)
{
	$actions['uptime_on']="Enable Uptime Check";
	$actions['uptime_off']="Disable Uptime Check";

	return($actions);
}

function uptime_device_action_execute ($action) {
        global $config;

        if ( ($action != 'uptime_off') && ($action != 'uptime_on') ) return $action;

	$which = '';
	if($action == 'uptime_off') $which = 'off';
	if($action == 'uptime_on') $which = 'on';
       	
	if($which != '')
	{ 
        $selected_items = unserialize(stripslashes($_POST["selected_items"]));

        for ($i=0; ($i < count($selected_items)); $i++) {
                input_validate_input_number($selected_items[$i]);
		
		db_execute("update host set uptime='".$which."' where id='" . $selected_items[$i] . "'");
	
                // autocreate($selected_items[$i]);
        }
	}
        return $action;
}

function uptime_device_action_prepare ($save) {
	global $colors, $host_list;
	if ($save['drp_action'] == 'uptime_on')
	{
 		print " <tr> <td colspan='2' class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
			<p>To enable uptime checking on all of these hosts, press the \"yes\" button below.</p> <p>" . $save['host_list'] . "</p> </td> </tr>";
	
	}
	elseif ($save['drp_action'] == 'uptime_off')
	{
		print " <tr><td colspan='2' class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
			<p>To disable uptime checking on all of these hosts, press the \"yes\" button below.</p> <p>" . $save['host_list'] . "</p> </td></tr>";
	} else {
		   return $save;
	}
}


function uptime_config_form () {
	global $fields_host_edit;
	$fields_host_edit2 = $fields_host_edit;
	$fields_host_edit3 = array();
	foreach ($fields_host_edit2 as $f => $a) {
		$fields_host_edit3[$f] = $a;
		if ($f == 'disabled') {
			$fields_host_edit3["uptime"] = array(
				"method" => "checkbox",
				"friendly_name" => "Check uptime",
				"description" => "Check this box to monitor uptime for this host.",
				"value" => "|arg1:uptime|",
				"default" => "",
				"form_id" => false
			);
		} 
	}
	$fields_host_edit = $fields_host_edit3;
}

function uptime_setup_table () {
	global $config, $database_default;
	include_once($config["library_path"] . "/database.php");
	$sql = "show columns from host from `" . $database_default . "`";
	$result = mysql_query($sql) or die (mysql_error());
	$found = false;
	while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
		if ($row['Field'] == 'uptime')
			$found = true;
	}
	if (!$found) {
		$sql = "alter table host add uptime char(3) default 'on' not null after disabled";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "CREATE TABLE uptime ( id mediumint(8) unsigned NOT NULL default '0', uptime bigint(20) default NULL)";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "CREATE TABLE uptime_data ( id mediumint(8) unsigned NOT NULL default '0', datetime datetime NOT NULL default '0000-00-00 00:00:00', extra text)";
		$result = mysql_query($sql) or die (mysql_error());
	}
}

function uptime_poller_bottom () {
	global $config;

	uptime_setup_table();
	$p = dirname(__FILE__);

	if ($config["cacti_server_os"] == "unix") {
		$command_string = read_config_option("path_php_binary");
		$extra_args = "-q " . $p . "/check-uptime.php";
	} else {
		$command_string = read_config_option("path_php_binary");
		$extra_args = "-q " . strtolower($p . "/check-uptime.php");
	}
	exec_background($command_string, $extra_args);
}



function uptime_api_device_save ($save) {
	if (isset($_POST['uptime']))
		$save["uptime"] = form_input_validate($_POST['uptime'], "uptime", "", true, 3);
	else
		$save['uptime'] = form_input_validate('', "uptime", "", true, 3);
	return $save;
}

function uptime_config_arrays () {
	global $user_auth_realms, $user_auth_realm_filenames;
	$user_auth_realms[55]='View/edit Uptime';
	$user_auth_realm_filenames['uptime.php'] = 55;
}

function uptime_show_tab () {
	global $config, $user_auth_realms, $user_auth_realm_filenames;
	$realm_id2 = 0;

	if (isset($user_auth_realm_filenames{basename('uptime.php')})) {
		$realm_id2 = $user_auth_realm_filenames{basename('uptime.php')};
	}
	if ((db_fetch_assoc("select user_auth_realm.realm_id
		from user_auth_realm where user_auth_realm.user_id='" . $_SESSION["sess_user_id"] . "'
		and user_auth_realm.realm_id='$realm_id2'")) || (empty($realm_id2))) {

		print '<a href="' . $config['url_path'] . 'plugins/uptime/uptime.php"><img src="' . $config['url_path'] . 'plugins/uptime/images/tab_uptime.png" alt="Uptime" align="absmiddle" border="0"></a>';

	}
	uptime_setup_table();
}

function uptime_draw_navigation_text ($nav) {
   $nav["uptime.php:"] = array("title" => "Uptime", "mapping" => "index.php:", "url" => "uptime.php", "level" => "1");
   $nav["uptime.php:actions"] = array("title" => "Uptime", "mapping" => "index.php:", "url" => "uptime.php", "level" => "1");   
   return $nav;
}


?>
